/*
 * 机具解绑记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MachineUnBindController : BaseController
    {
        public MachineUnBindController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 机具解绑记录列表

        /// <summary>
        /// 根据条件查询机具解绑记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MachineUnBind data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询机具解绑记录列表

        /// <summary>
        /// 机具解绑记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MachineUnBind data, string BrandIdSelect, string AuditStatusSelect, string MerchantIdMerchantName, string MerchantIdKqMerNo, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("SnNo", "1"); //机具SN
            Fields.Add("AuditDate", "3"); //审核时间


            string condition = " and Status>-1";
            //机具产品类型
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }
            //审核状态
            if (!string.IsNullOrEmpty(AuditStatusSelect))
            {
                condition += " and AuditStatus=" + AuditStatusSelect;
            }
            //解绑商户商户姓名
            if (!string.IsNullOrEmpty(MerchantIdMerchantName))
            {
                condition += " and MerchantId in (select MerchantId from PosMerchantInfoForMerchantName where MerchantName='" + MerchantIdMerchantName + "')";
            }
            //解绑商户渠道商户编码
            if (!string.IsNullOrEmpty(MerchantIdKqMerNo))
            {
                condition += " and MerchantId in (select MerchantId from PosMerchantInfoForKqMerNo where KqMerNo='" + MerchantIdKqMerNo + "')";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MachineUnBind", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdRealName"] = userid_Users.RealName;
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdMobile"] = userid_Users.Mobile;
                dic.Remove("UserId");
                //机具产品类型
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                //审核状态
                int AuditStatus = int.Parse(dic["AuditStatus"].ToString());
                if (AuditStatus == 0) dic["AuditStatus"] = "未审核";
                if (AuditStatus == 1) dic["AuditStatus"] = "审核通过，处理成功";
                if (AuditStatus == 2) dic["AuditStatus"] = "审核失败";
                //解绑商户
                int MerchantId = int.Parse(function.CheckInt(dic["MerchantId"].ToString()));
                PosMerchantInfo merchantid_PosMerchantInfo = db.PosMerchantInfo.FirstOrDefault(m => m.Id == MerchantId) ?? new PosMerchantInfo();
                dic["MerchantIdMerchantName"] = merchantid_PosMerchantInfo.MerchantName;
                dic["MerchantIdKqMerNo"] = merchantid_PosMerchantInfo.KqMerNo;
                dic.Remove("MerchantId");

            }
            return Json(obj);
        }

        #endregion

        #region 增加机具解绑记录

        /// <summary>
        /// 增加或修改机具解绑记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加机具解绑记录

        /// <summary>
        /// 增加或修改机具解绑记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MachineUnBind data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("BrandId", data.BrandId); //机具产品类型
            Fields.Add("SnNo", data.SnNo); //机具SN

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("MachineUnBind", Fields, 0);
            AddSysLog(data.Id.ToString(), "MachineUnBind", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改机具解绑记录

        /// <summary>
        /// 增加或修改机具解绑记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            MachineUnBind editData = db.MachineUnBind.FirstOrDefault(m => m.Id == Id) ?? new MachineUnBind();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改机具解绑记录

        /// <summary>
        /// 增加或修改机具解绑记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MachineUnBind data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("BrandId", data.BrandId); //机具产品类型
            Fields.Add("SnNo", data.SnNo); //机具SN

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineUnBind", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "MachineUnBind", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除机具解绑记录信息

        /// <summary>
        /// 删除机具解绑记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineUnBind", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineUnBind", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineUnBind", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineUnBind", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MachineUnBind", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("MachineUnBind", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("MachineUnBind", Sort, Id);

            AddSysLog(Id.ToString(), "MachineUnBind", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.MachineUnBind.Add(new MachineUnBind()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "MachineUnBind", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MachineUnBind data, string BrandIdSelect, string AuditStatusSelect, string MerchantIdMerchantName, string MerchantIdKqMerNo)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("SnNo", "1"); //机具SN
            Fields.Add("AuditDate", "3"); //审核时间


            string condition = " and Status>-1";
            //机具产品类型
            if (!string.IsNullOrEmpty(BrandIdSelect))
            {
                condition += " and BrandId=" + BrandIdSelect;
            }
            //审核状态
            if (!string.IsNullOrEmpty(AuditStatusSelect))
            {
                condition += " and AuditStatus=" + AuditStatusSelect;
            }
            //解绑商户商户姓名
            if (!string.IsNullOrEmpty(MerchantIdMerchantName))
            {
                condition += " and MerchantId in (select MerchantId from PosMerchantInfoForMerchantName where MerchantName='" + MerchantIdMerchantName + "')";
            }
            //解绑商户渠道商户编码
            if (!string.IsNullOrEmpty(MerchantIdKqMerNo))
            {
                condition += " and MerchantId in (select MerchantId from PosMerchantInfoForKqMerNo where KqMerNo='" + MerchantIdKqMerNo + "')";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("MachineUnBind", Fields, "Id desc", "0", 1, 20000, condition, "ApplyNo,UserId,BrandId,SnNo,AuditStatus,AuditDesc,AuditDate,MerchantId", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdRealName"] = userid_Users.RealName;
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdMobile"] = userid_Users.Mobile;
                dic.Remove("UserId");
                //机具产品类型
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                //审核状态
                int AuditStatus = int.Parse(dic["AuditStatus"].ToString());
                if (AuditStatus == 0) dic["AuditStatus"] = "未审核";
                if (AuditStatus == 1) dic["AuditStatus"] = "审核通过，处理成功";
                if (AuditStatus == 2) dic["AuditStatus"] = "审核失败";
                //解绑商户
                int MerchantId = int.Parse(function.CheckInt(dic["MerchantId"].ToString()));
                PosMerchantInfo merchantid_PosMerchantInfo = db.PosMerchantInfo.FirstOrDefault(m => m.Id == MerchantId) ?? new PosMerchantInfo();
                dic["MerchantIdMerchantName"] = merchantid_PosMerchantInfo.MerchantName;
                dic["MerchantIdKqMerNo"] = merchantid_PosMerchantInfo.KqMerNo;
                dic.Remove("MerchantId");

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("ApplyNo", "解绑申请单号");
            ReturnFields.Add("UserIdRealName", "创客真实姓名");
            ReturnFields.Add("UserIdMakerCode", "创客编号");
            ReturnFields.Add("UserIdMobile", "创客手机号");
            ReturnFields.Add("BrandId", "机具产品类型");
            ReturnFields.Add("SnNo", "机具SN");
            ReturnFields.Add("AuditStatus", "审核状态");
            ReturnFields.Add("AuditDesc", "审核描述");
            ReturnFields.Add("AuditDate", "审核时间");
            ReturnFields.Add("MerchantIdMerchantName", "解绑商户商户姓名");
            ReturnFields.Add("MerchantIdKqMerNo", "解绑商户渠道商户编码");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MachineUnBind", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
